*-----------------------------------------------------------
* Title      : Subroutines
* Written by : DK
* Date       : Dec 2019
* Description: ASCII to BIN (ver. 1)
*-----------------------------------------------------------
        ORG     $400400
ASCE    DC.B    '3','4','5'

        ORG		$400420
      	LEA     ASCE,A0
        JSR     DECBIN
        STOP    #$2700

DECBIN  CLR.L	D0	        Clear result register		
	    MOVEQ	#3,D6	    Initialize loop counter to get 3 digits
	    
NEXTD	CLR.L	D1	        Clear new digit holding register
	    MOVE.B	(A0)+,D1	Get one ASCII digit from memory
	    SUB.B	#$30,D1	    Subtract ASCII bias $30
	    MULU	#10,D0	    Multiply D0 by 10
	    ADD.W	D1,D0	    Add new digit to binary value in D0
	    SUB.B	#1,D6	    Decrement counter
	    BNE	    NEXTD	    If not done get next digit
	    RTS

        END $400420








*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~4~
